
#include "ts4300.h"

void ack_startup(void) {
	POKE32(0x12000, get_us());
}

void shutdown(void) {
	POKE32(CTL, PEEK32(CTL) | LM32_RST);
}

unsigned int get_us(void) {
	return PEEK32(TIMER);
}

void usleep(unsigned int usec) {
	unsigned int t1;
	t1 = get_us();
	while (get_us() - t1 < usec) {};
}

void outstr(char *s) {
	unsigned int i = 0, j = 0;
	while (s[i] != 0) {
		while (j <= 1) {
			j = PEEK8(FIFO_STAT);
			if (j & 0x40) j = 0; // full
			else if (!(j & 0x20)) j = 0x3e0; // mostly empty
			else if ((j & 0x30) == 0x30) j = 0; // mostly full
			else j = 0x3e0 - ((j & 0xf) << 6);
		}
		if (s[i] == 0xa) { // add line feed to newline
			POKE8(FIFO_DAT, 0xd);
			j--;
		}
		POKE8(FIFO_DAT, s[i]);
		j--;
		i++;
	}
}

void outint(unsigned int x) {
	if (x & 0x80000000) {
		outstr("-");
		outint(0 - x);
		return;
	}
	if (x > 9) outint(x/10);

	while(PEEK8(FIFO_STAT) & 0x40) {}; // fifo full
	POKE8(FIFO_DAT, '0' + x%10);
}

void outhex(unsigned int x) {
	unsigned char d;

	if (x & 0xfffffff0) outhex(x >> 4);
	while(PEEK8(FIFO_STAT) & 0x40) {}; // fifo full
	d = x & 0xf;
	if (d > 9) POKE8(FIFO_DAT, 'a' - 10 + d);
	else POKE8(FIFO_DAT, '0' + d);
}
