#define BASE8 0x80000000
#define BASE32 0x90000000
#define BASE16 0xa0000000
#define PEEK32(adr) (*(unsigned int *)((adr) + BASE32))
#define POKE32(adr, val) *(unsigned int *)((adr) + BASE32) = (val)
#define PEEK16(adr) (*(unsigned short *)((adr) + BASE16))
#define POKE16(adr, val) *(unsigned short *)((adr) + BASE16) = (val)
#define PEEK8(adr) (*(unsigned char *)((adr) + BASE8))
#define POKE8(adr, val) *(unsigned char *)((adr) + BASE8) = (val)

#define ID             0x00
#define CTL            0x04
#define MUXBUS_CONFIG  0x10
#define TIMER          0x14
#define FIFO_DAT       0x800
#define FIFO_STAT      0x801

#define MUXBUS8        0x30000
#define MUXBUS16       0x20000
#define SHM            0x12000

#define ADC_CONF       0x700
#define ADC_MASK       0x702
#define ADC_DAT(chan)  (0x702 + 2*(chan))

#define RED_LED      (1<<0)
#define GREEN_LED    (1<<1)
#define LM32_RST     (1<<23)

/* If you use the stock ts4300ctl utility to load this program into the LM32,
 * it assumes the first thing the LM32 does is call ack_startup().  This is
 * used to report the load time.
 */
void ack_startup(void);

/* The shutdown() function will put the LM32 in reset.  It will stay in reset
 * until the ARM host releases reset.
 */
void shutdown(void);

/* Get 32 bit microsecond timer value.
 */
unsigned int get_us(void);

/* This usleep() function does not return until the requested time has
 * elapsed.  It is accurate to within 1 microsecond.
 */
void usleep(unsigned int);

/* This function sends a text string to the console FIFO.
 */
void outstr(char *);

/* This function converts an integer to text and sends it to the FIFO, similar
 * to printf("%d", x)
 */
void outint(unsigned int);

/* This function converts an integer to text and sends it to the FIFO, similar
 * to printf("%x", x)
 */
void outhex(unsigned int);


